<?php
/**
 * @package     ContentBuilder
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
 */
defined( '_JEXEC' ) or die( 'Restricted access' );

@ob_end_clean();

require_once(JPATH_COMPONENT_ADMINISTRATOR . DS . 'classes' . DS . 'contentbuilder_helpers.php');
define(K_PATH_IMAGEs, __DIR__.'/../../../classes/images');
require_once(__DIR__.'/../../../classes/tcpdf.php');
require_once(__DIR__.'/../../../classes/PHPExcel.php');
//Export if there is pdf on URL (in list template button)
if(($_GET['type']=='pdf'))
{
   
    class MYPDF extends TCPDF {
        
            //Page header
            public function Header() {
                // Logo
                $image_file = K_PATH_IMAGES.'crosstec.png';
                $this->Image($image_file, 20, 5, 80, '', 'PNG', '', 'T', false, 300, '', false, false, 0, false, false, false);
                // Set font
                $this->SetFont('helvetica', 'B', 20);
                $this->Multicell(0,2,"\n\n");                 
                $this->SetLineStyle(array('width' => 1 / $this->k, 'cap' => 'butt', 'join' => 'miter', 'dash' => 0, 'color' => $headerdata['line_color']));
                $this->SetY((2.835 / $this->k) + max($imgy, $this->y));
                if ($this->rtl) {
                    $this->SetX($this->original_rMargin);
                } else {
                    $this->SetX($this->original_lMargin);
                }
                $this->Cell(($this->w - $this->original_lMargin - $this->original_rMargin), 0, '', 'T', 0, 'C');                                
                $this->Cell(($this->w - $this->original_lMargin - $this->original_rMargin), 0, '', 'T', 0, 'C');                
                
            }
        
            // Page footer
            public function Footer() {
                // Position at 15 mm from bottom
                $this->SetY(-15);
                // Set font
                $this->SetFont('helvetica', 'I', 8);
                // Page number
                $this->Cell(0, 10, 'Page '.$this->getAliasNumPage().'/'.$this->getAliasNbPages(), 0, false, 'C', 0, '', 0, false, 'T', 'M');
            }
        }

        // create new PDF document
$pdf = new MYPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);
$pdf->SetHeaderData(PDF_HEADER_LOGO, PDF_HEADER_LOGO_WIDTH, PDF_HEADER_TITLE.' 035', PDF_HEADER_STRING);

// set document information
$pdf->SetCreator(PDF_CREATOR);
$pdf->SetAuthor('Crosstec');


// set header and footer fonts
$pdf->setHeaderFont(Array(PDF_FONT_NAME_MAIN, '', PDF_FONT_SIZE_MAIN));
$pdf->setFooterFont(Array(PDF_FONT_NAME_DATA, '', PDF_FONT_SIZE_DATA));


// set default monospaced font
$pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);

// set margins
$pdf->SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT);
$pdf->SetHeaderMargin(PDF_MARGIN_HEADER);
$pdf->SetFooterMargin(PDF_MARGIN_FOOTER);


// set image scale factor
$pdf->setImageScale(PDF_IMAGE_SCALE_RATIO);

// set some language-dependent strings (optional)
if (@file_exists(dirname(__FILE__).'/lang/eng.php')) {
	require_once(dirname(__FILE__).'/lang/eng.php');
	$pdf->setLanguageArray($l);
}

// ---------------------------------------------------------

// add a page
$pdf->AddPage();

$pdf->SetFont('helvetica', '', 8);

// -----------------------------------------------------------------------------
$header = $this->data->visible_labels;
$data = $this->data->items;
$headers = '';
$tableData ='';

$headers .= '
<style>
table {
    border: 1px solid #AAAAAA;
    width: 100%;
    text-align: left;
    border-collapse: collapse;
  }
  table td, table th {
    border: 1px solid #AAAAAA;
    padding: 3px 2px;
  }  
  </style>
<thead>
<tr style= "font-weight:bold; font-size:10;">';
if($this->data->show_id_column)
$headers .= '<th>'.JText::_('COM_CONTENTBUILDER_ID').'</th>';
foreach($header As $label){
    $headers .= '<th>' .$label.'</th>';
}
$headers .= '</tr></thead><tfoot>';
foreach($data as $item){
    $tableData .= '<tr style= "font-size:10;">';
    if($this->data->show_id_column)
    $tableData .= '<td>'.$item->colRecord.'</td>';
foreach($item As $key => $value){
    if($key != 'colRecord' && in_array(str_replace('col','',$key), $this->data->visible_cols)){
        $tableData .= "<td>".$value."</td>";
    }
        }
        $tableData .= '</tr>';        
}
$tbl = '';
$tbl .= "<table>".$headers."
                    ".$tableData."
                </tfoot></table>"; 


$pdf->writeHTML($tbl, true, false, false, false, '');

$filename = "export-".date('Y-m-d_Hi').".pdf";
//Close and output PDF document
$pdf->Output($filename, 'I');

}

//CSV export
else if(($_GET['type']=='csv')){
    $headers = $this->data->visible_labels;
    $items = $this->data->items;
    $data = array();
      // output headers so that the file is downloaded rather than displayed
header('Content-type: text/csv');
header('Content-Disposition: attachment; filename="demo.csv"');
 
// do not cache the file
header('Pragma: no-cache');
header('Expires: 0');
 
// create a file pointer connected to the output stream
$file = fopen('php://output', 'w');
 
//Setting data array from database values
foreach($items as $item){
    foreach($item As $key => $value){
 if($key != 'colRecord' && in_array(str_replace('col','',$key), $this->data->visible_cols))
    $data[] = $value;
    }        

}
// send the column headers
fputcsv($file, $headers);
 
 
// output each row of the data
fputcsv($file, $data);
 
exit();


}
//Export for .xlsx
else {
    
$objPHPExcel = new PHPExcel();

$objPHPExcel->getProperties()->setCreator("ContentBuilder")
->setLastModifiedBy("ContentBuilder");
$c = 'A';
$i = 1;
    if($this->data->show_id_column){
    $objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue("$c"."$i", JText::_('COM_CONTENTBUILDER_ID'));
    $c++;  
    }
    if($this->data->list_state){
	$objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue("$c"."$i", "List state");
    $c++;
    }
    if($this->data->list_publish){
    $objPHPExcel->setActiveSheetIndex(0)
    ->setCellValue("$c"."$i", "Published");
    $c++;}

    foreach($this->data->visible_labels As $label){
        $cell = "$c"."$i";
        $objPHPExcel->setActiveSheetIndex(0)
        ->setCellValue($cell, $label); 
        $c++; 
    }

    $ch='A';
    $i=2;
    foreach($this->data->items As $item){
        for($ch='A';$ch<=$c;$ch++){
            if($this->data->show_id_column){
        $objPHPExcel->setActiveSheetIndex(0)
        ->setCellValue("$ch"."$i", $item->colRecord); 
        $ch++;
            }
        //List state
        if($this->data->list_state){

        $database = JFactory::getDBO();
        $sql = "SELECT title, color FROM `#__contentbuilder_list_states` WHERE id = (SELECT state_id FROM `#__contentbuilder_list_records` WHERE record_id = $item->colRecord)"; // Select data from DB
        $database->setQuery( $sql );
        $result = $database->loadRow();
        $objPHPExcel->setActiveSheetIndex(0)
        ->setCellValue("$ch"."$i", $result[0]);
        if($result[1] < 1) $result[1] = 'FFFFFF';
        if($result[1] != 'FFFFFF'){
        $sharedStyle1 = new PHPExcel_Style();
$sharedStyle1->applyFromArray(
	array('fill' 	=> array(
								'type'		=> PHPExcel_Style_Fill::FILL_SOLID,
								'color'		=> array('rgb' => $result[1])
							)
		 ));
$objPHPExcel->getActiveSheet()->setSharedStyle($sharedStyle1, "$ch"."$i");
        }
        $ch++;
    }
    
        //Published
        if($this->data->list_publish){
        $database1 = JFactory::getDBO();
        $sql = "SELECT `state` FROM `#__content` WHERE id = (SELECT article_id FROM `#__contentbuilder_articles` WHERE record_id = $item->colRecord)"; // Select data from DB
        $database1->setQuery( $sql );
        $result = $database1->loadResult();
        if($result != 0){
            $objPHPExcel->setActiveSheetIndex(0)
            ->setCellValue("$ch"."$i", 'Yes');
            }
        else {
            $objPHPExcel->setActiveSheetIndex(0)
            ->setCellValue("$ch"."$i", 'No');
            }
            $ch++;
        }

        foreach($item As $key => $value){
            if($key != 'colRecord' && in_array(str_replace('col','',$key), $this->data->visible_cols)){
                $cell="$ch"."$i";
                    $objPHPExcel->setActiveSheetIndex(0)
                    ->setCellValue($cell, $value);  
                $ch++;
            }
            
        }
        $i++;
        }
    }
    

$objPHPExcel->getDefaultStyle()->getAlignment()->setWrapText(true);
$cell_length = 0;
for($col='A';$col<$ch;$col++){
    for($row=1;$row<$i;$row++){
        $cell="$col"."$row";
        $length = strlen($objPHPExcel->getActiveSheet()->getCell($cell)->getValue());
        if($length > $cell_length){
            $cell_length = $length;
        }
        $objPHPExcel->getActiveSheet()
        ->getStyle($cell)
        ->getNumberFormat()
        ->setFormatCode( PHPExcel_Style_NumberFormat::FORMAT_TEXT ); 
    }
    if($cell_length < 1){
        $width = 15;
    }
    else if($cell_length <= 50){
        $width = $cell_length + 5;
    }
    else {
        $width = $cell_length/3;
    }
    $objPHPExcel->getActiveSheet()->getColumnDimension($col)->setWidth($width);
    $cell_length = 0;
       
}



$objPHPExcel->getActiveSheet()->setTitle("export-".date('Y-m-d_Hi').".xlsx");


$filename = "export-".date('Y-m-d_Hi').".xlsx";
$objPHPExcel->setActiveSheetIndex(0);


// Redirect output to a client’s web browser (Excel5)
header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
header('Content-Disposition: attachment; filename=' . $filename);
header('Cache-Control: max-age=0');
// If you're serving to IE 9, then the following may be needed
header('Cache-Control: max-age=1');

// If you're serving to IE over SSL, then the following may be needed
header ('Expires: Mon, 26 Jul 1997 05:00:00 GMT'); // Date in the past
header ('Last-Modified: '.gmdate('D, d M Y H:i:s').' GMT'); // always modified
header ('Cache-Control: cache, must-revalidate'); // HTTP/1.1
header ('Pragma: public'); // HTTP/1.0

$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel2007');
$objWriter->save('php://output');

exit;
}
?>